﻿using System.Text;

namespace S7Explorer.Models
{
    public class SymbolItem : ProjectItem
    {
        public object? SymbolData { get; set; }
        public string SymbolAddress { get; set; } = string.Empty;
        public string SymbolDataType { get; set; } = string.Empty;
        public string SymbolComment { get; set; } = string.Empty;

        public override object? GetDetailsObject()
        {
            return SymbolData;
        }

        public override string GetIcon()
        {
            return "Symbol";
        }

        public override string GetExportText()
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine($"Symbol: {Name}");
            sb.AppendLine($"Address: {SymbolAddress}");
            sb.AppendLine($"Data Type: {SymbolDataType}");

            if (!string.IsNullOrEmpty(SymbolComment))
                sb.AppendLine($"Comment: {SymbolComment}");

            sb.AppendLine();

            return sb.ToString();
        }
    }
}